HaskellForMaths-0.4.5: Combinatorics, group theory, commutative algebra, non-commutative algebra

Safe Haskell | None

Math.Algebras.NonCommutative

Description

A module defining the algebra of non-commutative polynomials over a field k

# Documentation

data NonComMonomial v Source

Constructors

NCM Int [v] |

Instances

Monomial NonComMonomial |
(Eq k, Num k, Ord v) => Algebra k (NonComMonomial v) |
Eq v => Eq (NonComMonomial v) |
Ord v => Ord (NonComMonomial v) |
(Eq v, Show v) => Show (NonComMonomial v) |
Mon (NonComMonomial v) |
Eq v => DivisionBasis (NonComMonomial v) |

class Monomial m where Source

Methods

var :: v -> Vect Q (m v)Source

powers :: Eq v => m v -> [(v, Int)]Source

Instances

Monomial NonComMonomial |
Monomial SL2q |
Monomial M2q |
Monomial Aq02 |
Monomial Aq20 |

bind :: (Eq k, Eq v, Num k, Ord b, Show b, Algebra k b, Monomial m) => Vect k (m v) -> (v -> Vect k b) -> Vect k bSource

type NCPoly v = Vect Q (NonComMonomial v)Source

class DivisionBasis m where Source

Methods

divM :: m -> m -> Maybe (m, m)Source

Instances

Eq v => DivisionBasis (NonComMonomial v) |

ncm :: [v] -> NonComMonomial vSource

lm :: Vect t t1 -> t1Source

lc :: Vect t t1 -> tSource

lt :: Vect k b -> Vect k bSource

quotRemNP :: (Eq k, Fractional k, Ord m, Show m, Algebra k m, DivisionBasis m) => Vect k m -> [Vect k m] -> ([(Vect k m, Vect k m)], Vect k m)Source

remNP :: (Eq k, Fractional k, Ord m, Show m, Algebra k m, DivisionBasis m) => Vect k m -> [Vect k m] -> Vect k mSource

(%%) :: (Eq k, Fractional k, Ord m, Show m, Algebra k m, DivisionBasis m) => Vect k m -> [Vect k m] -> Vect k mSource